from JarvisML.utils.logger.log_entry_exit import log_entry_exit

from nltk.corpus import wordnet
from nltk.corpus import stopwords


class AddDictionaryMeaning:
    def __init__(self, meaning_max_length=200, stop_words_lang='english', stop_words=None):
        self.stop_words = stop_words if stop_words else list(stopwords.words(stop_words_lang))
        self.meaning_max_length = meaning_max_length

    @log_entry_exit(log_time=False)
    def run(self, data, **kwargs):
        processed_data = []
        for text in data:
            definitions = []
            stop_iteration = False
            for word in text.split():
                if word not in self.stop_words:
                    for synset in wordnet.synsets(word):
                        definitions += [word_in_meaning for word_in_meaning in synset.definition().split()]
                        if len(definitions) >= self.meaning_max_length:
                            stop_iteration = True
                            break
                    if stop_iteration:
                        break
            definition_to_add = ' '.join(definitions[:self.meaning_max_length])
            processed_data.append(' '.join([text, definition_to_add]))

        return processed_data