from JarvisML.utils.logger.log_entry_exit import log_entry_exit

from nltk.stem import WordNetLemmatizer


class Lemmatize:

    @log_entry_exit(log_time=False)
    def run(self, data, **kwargs):
        processed_data = []
        for text in data:
            wordnet_lemmatizer = WordNetLemmatizer()
            lemmatized_words = [wordnet_lemmatizer.lemmatize(x, **kwargs) for x in text.split()]
            processed_data.append(' '.join(lemmatized_words))

        return processed_data
