from JarvisML.utils.logger.log_entry_exit import log_entry_exit
from nltk.corpus import stopwords


class RemoveStopWords:
    def __init__(self, stop_words_lang='english', stop_words=None):
        self.stop_words = stop_words if stop_words else list(stopwords.words(stop_words_lang))

    @log_entry_exit(log_time=False)
    def run(self, data, **kwargs):
        processed_data = []
        for text in data:
            processed_instance = [word for word in text.split() if word not in self.stop_words]
            processed_data.append(' '.join(processed_instance))

        return processed_data
