import pandas as pd
from tqdm import tqdm
from deep_translator import GoogleTranslator


def get_call_translation(filepath):
    df_pandas = pd.read_csv(filepath)

    def translate_large_text(text, translator_object):
        parts = 1
        success = False
        words = text.split(" ")

        while not success:
            translation = ""
            try:
                for i in range(0, parts):
                    section = " ".join(words[i * (len(words) // parts):(i + 1) * (len(words) // parts)])
                    translated_section = translator_object.translate(text=section)
                    translation += translated_section + " "
                success = True
            except Exception as e:
                parts *= 2

        return translation

    df_pandas['se_translated_transcript'] = ""
    df_pandas['lead_translated_transcript'] = ""

    g_translator = GoogleTranslator(source='hindi', target='en')

    for i in tqdm(range(df_pandas.shape[0])):
        try:
            df_pandas['se_translated_transcript'][i] = translate_large_text(
                eval(df_pandas['responses'][i])['results'][0]['transcription']['0'], g_translator)
        except:
            df_pandas['se_translated_transcript'][i] = ""
        try:
            df_pandas['lead_translated_transcript'][i] = translate_large_text(
                eval(df_pandas['responses'][i])['results'][0]['transcription']['1'], g_translator)
        except:
            df_pandas['lead_translated_transcript'][i] = ""

    return df_pandas