import os
import re
import requests
from io import BytesIO
from pydub import AudioSegment


def download_audio(url, path_to_store=None, store=False):
    if len(re.findall("\.(mp3|wav)", url)) > 0:
        USER_AGENT = {'User-agent': 'Mozilla/5.0'}
        r = requests.get(url, allow_redirects=True)
        file_name = (url.split("?")[0].split('/')[-1]).split(".")[0]

        sound = AudioSegment.from_file(BytesIO(r.content))

        if store:
            sound.export(os.path.join(path_to_store, "{}.wav".format(file_name)), format="wav")

        return sound
