import numpy as np
import librosa


def get_melspectogram(audio, rate=16000):

    sgram = librosa.stft(np.array(audio.get_array_of_samples()).astype(np.float32))
    sgram_mag, _ = librosa.magphase(sgram)
    mel_scale_sgram = librosa.feature.melspectrogram(S=sgram_mag, sr=rate)
    mel_sgram = librosa.amplitude_to_db(mel_scale_sgram, ref=np.min)

    return mel_sgram
