import boto3
import pandas as pd
import json
import botocore
from tqdm import tqdm
import logging
tqdm.pandas()


def access_transcript_s3():
    txr_urls = pd.DataFrame()

    def get_transcription_data(asr_uuid):
        s3 = boto3.resource("s3")
        key = "{0}.json".format(asr_uuid)
        bucket_name = "squad-transcription-data"
        obj = s3.Bucket(bucket_name).Object(key)

        try:
            response = obj.get()
        except botocore.exceptions.ClientError as error:
            logging.logger.info("Error in fetching transcription from s3 bucket for asr_uuid : {0}".format(asr_uuid))
            return error.response["ResponseMetadata"]["HTTPStatusCode"], None

        data = response["Body"].read().decode("utf-8")
        resp_data = json.loads(data)

        return resp_data

    # txr_urls is the dataframe which contains raw_data_s3_url
    # from the table voice_integrations_vpmtranscriptdataasr
    txr_urls["raw_data"] = txr_urls["raw_data_s3_url"].progress_apply(
        lambda x: get_transcription_data(x.split("/")[-1].split(".")[0]))
    
    return txr_urls