import boto3
import pandas as pd
from tqdm import tqdm
tqdm.pandas()


def fetch_files_from_s3_bucket(bucket_name):
    # Initialize an S3 client
    s3 = boto3.client('s3')
    # Replace with your S3 bucket name
    bucket_name = 'transcription-pipeline-prod'
    # List objects in the S3 bucket
    response = s3.list_objects_v2(Bucket=bucket_name, Prefix='input/20231004')
    # Iterate through the objects in the bucket
    for obj in response.get('Contents', []):
        # Extract the key (object key) and the folder name
        object_key = obj['Key']
        try:
            csv_data = s3.get_object(Bucket=bucket_name, Key=object_key)
            df_temp = pd.read_csv(csv_data['Body'])
            df_temp.to_csv('data/{}.csv'.format(object_key.split("/")[-2]))
        except:
            print("failed to fetch csv: ", object_key.split("/")[-2])
