
def format_asr_prediction(prediction, utterances=True):
    """
    Function to restore punctuation to un-punctuated ASR pipeline response
    param response['results']: [
                {
                    'ID': ...
                    ...
                    'transcription': {
                            0: 'transcript channel 0',
                            1: 'transcript channel 1',
                            2: 'transcript channel 2',
                    }
                },
                {
                    'ID': ...
                    ...
                    'transcription': {
                            0: 'transcript channel 0',
                            1: 'transcript channel 1',
                            2: 'transcript channel 2',
                    }
                }
            ]

    """
    for index in range(len(prediction)):
        for k, v in prediction[index]['transcription'].items():
            prediction[index]['transcription'][k] = smart_format_string(
                prediction[index]['transcription'][k]
            )

        if utterances:
            for i in range(len(prediction[index]['utterances'])):
                prediction[index]['utterances'][i]['utterance'] = smart_format_string(
                    prediction[index]['utterances'][i]['utterance']
                )

    return prediction
