from nltk.tokenize import sent_tokenize


def smart_format_string(text):
    """Run formatting on individual text"""

    # Fix contractions
    contract = {
        '< u <unclear> >': '<unclear>',
        '<unclear> >': '<unclear>',
        '<audio_silent >': '<audio_silent>',
        '<audio_silent ': '<audio_silent> ',
        'ain t': "ain't",
        'aren t': "aren't",
        'can t': "can't",
        'cause': 'cause',
        'could ve': "could've",
        'couldn t': "couldn't",
        'couldn t ve': "couldn't've",
        'didn t': "didn't",
        'doesn t': "doesn't",
        'don t': "don't",
        'hadn t': "hadn't",
        'hadn t ve': "hadn't've",
        'hasn t': "hasn't",
        'haven t': "haven't",
        'he d': "he'd",
        'he d ve': "he'd've",
        'he ll': "he'll",
        'he ll ve': "he'll've",
        'he s': "he's",
        'how d': "how'd",
        'how d ve': "how'd've",
        'how ll': "how'll",
        'how s': "how's",
        'I d': "I'd",
        'I d ve': "I'd've",
        'I ll': "I'll",
        'I ll ve': "I'll've",
        'I m': "I'm",
        'I ve': "I've",
        'i d': "i'd",
        'i d ve': "i'd've",
        'i ll': "i'll",
        'i ll ve': "i'll've",
        'i m': "i'm",
        'i ve': "i've",
        'isn t': "isn't",
        'it d': "it'd",
        'it d ve': "it'd've",
        'it ll': "it'll",
        'it ll ve': "it'll've",
        'it s': "it's",
        'let s': "let's",
        'ma am': "ma'am",
        'mayn t': "mayn't",
        'might ve': "might've",
        'mightn t': "mightn't",
        'mightn t ve': "mightn't've",
        'must ve': "must've",
        'mustn t': "mustn't",
        'mustn t ve': "mustn't've",
        'needn t': "needn't",
        'needn t ve': "needn't've",
        'o clock': "o'clock",
        'oughtn t': "oughtn't",
        'oughtn t ve': "oughtn't've",
        'shan t': "shan't",
        'shall n t': "shall'n't",
        'shan t ve': "shan't've",
        'she d': "she'd",
        'she d ve': "she'd've",
        'she ll': "she'll",
        'she ll ve': "she'll've",
        'she s': "she's",
        'should ve': "should've",
        'shouldn t': "shouldn't",
        'shouldn t ve': "shouldn't've",
        'so ve': "so've",
        'so s': "so's",
        'that d': "that'd",
        'that d ve': "that'd've",
        'that s': "that's",
        'there d': "there'd",
        'there d ve': "there'd've",
        'there s': "there's",
        'they d': "they'd",
        'they d ve': "they'd've",
        'they ll': "they'll",
        'they ll ve': "they'll've",
        'they re': "they're",
        'they ve': "they've",
        'to ve': "to've",
        'wasn t': "wasn't",
        'we d': "we'd",
        'we d ve': "we'd've",
        'we ll': "we'll",
        'we ll ve': "we'll've",
        'we re': "we're",
        'weren t': "weren't",
        'what ll': "what'll",
        'what ll ve': "what'll've",
        'what re': "what're",
        'what s': "what's",
        'what ve': "what've",
        'when s': "when's",
        'when ve': "when've",
        'where d': "where'd",
        'where s': "where's",
        'where ve': "where've",
        'who ll': "who'll",
        'who ll ve': "who'll've",
        'who s': "who's",
        'who ve': "who've",
        'why s': "why's",
        'why ve': "why've",
        'will ve': "will've",
        'won t': "won't",
        'will t ve': "will't've",
        'would ve': "would've",
        'would t': "would't",
        'would t ve': "would't've",
        'y all': "y'all",
        'y all d': "y'all'd",
        'y all d ve': "y'all'd've",
        'y all re': "y'all're",
        'y all ve': "y'all've",
        'you d': "you'd",
        'you d ve': "you'd've",
        'you ll': "you'll",
        'you ll ve': "you'll've",
        'you re': "you're",
        'you ve': "you've"
    }
    for k in contract:
        text = text.replace(k, contract[k])

    # Fix capitalization
    output = ' '.join([x.capitalize() for x in sent_tokenize(text)])

    return output